#!/usr/bin/perl
#
# FloodWorld v1.0.a3 (Users Database Conversion Program)
#
# (C)Copyright 2001
# Brian M. King
# All Rights Reserved
#
# This program is provided as is, without warranty. The author is not liable
# for any and all actions as a result of the code herein.
#
if (!(defined($ARGV[0]))) {
   print "Syntax: ./a2toa3.pl CurrentUsersDataBase\n";
   exit;
}
open CFG, "fworld.cfg";
   @cfg = <CFG>;
close CFG;

foreach $conf (@cfg) {
   chomp($conf);
   @TempCFG = split(/\=/, $conf);
   $config{$TempCFG[0]} = $TempCFG[1];
}

if ((!(-e "md5/fwmd5")) && (lc($config{'EcryptPass'}) eq "yes")) {
   print "ERROR: You have not yet made fwmd5 ..\n";
   print "Type: cd md5\nThen: make\n";
   exit;
}

open USERS, "$ARGV[0]";
   @TUsers = <USERS>;
close USERS;

foreach $tu (@TUsers) {
   chomp($tu);
   @TempUsers = split(/::/, $tu);
   if (lc($config{'EncryptPass'}) eq "yes") {
      $tp = `md5/fwmd5 $TempUsers[3]`;
      chomp($tp);
   } else {
      $tp = $TempUsers[3];
   }
   $newusers{$TempUsers[0]}->{Pass} = $tp;
   $newusers{$TempUsers[0]}->{Level} = $TempUsers[4];
}

open NU, ">$ARGV[0]";
   foreach $WU (keys %newusers) {
      print NU $WU . "::" . $newusers{$WU}->{Pass} . "::" . $newusers{$WU}->{Level} . "\n";
   }
close NU;

open CFG, ">fworld.cfg";
   print CFG "RootAdminIdent\=" . $config{'RootAdminIdent'} . "\n";
   print CFG "Protocol\=" . $config{'Protocol'} . "\n";
   print CFG "RootAdminHost\=" . $config{'RootAdminHost'} . "\n";
   if (lc($config{'EncryptPass'}) eq "yes") {
      $TRAP = $config{'RootAdminPass'};
      $RAPass = `md5/fwmd5 $TRAP`;
      chomp($RAPass);
      print CFG "RootAdminPass\=" . $RAPass . "\n";
   } else {
      print CFG "RootAdminPass\=" . $config{'RootAdminPass'} . "\n";
   }
   print CFG "EncryptPass\=" . $config{'EncryptPass'} . "\n";
   print CFG "RootAdmin\=" . $config{'RootAdmin'} . "\n";
close CFG;
      
print "User's database has successfully been converted to use\n";
print "the v1.0.a3 format.\n";

